#include <bits/stdc++.h>

#define MAXN 50005
#define INF 1000000000000000000

using namespace std;

int n, m;
int destination, t;
vector<tuple<int, int, int, int, int>> g[MAXN];

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m >> destination >> t;
    for (int i = 0; i < m; i++) {
        int u, v, a, b, c, d; cin >> u >> v >> a >> b >> c >> d;
        g[u].push_back({v, a, b, c, d});
    }

    priority_queue<tuple<long long, int, int, int>> pq;
    pq.push({0, 1, 0, 0});

    long long ans = INF;

    while (!pq.empty()) {
        long long waiting;
        int u, minMoment, maxMoment; tie(waiting, u, minMoment, maxMoment) = pq.top();
        waiting = -waiting; pq.pop();

        if (u == destination) {
            if (maxMoment > t) continue;
            ans = min(ans, waiting + t - minMoment);
        }

        for (auto [v, a, b, c, d] : g[u]) {
            if (maxMoment <= a) {
                pq.push({-waiting - (b - minMoment), v, c, d});
            }
        }
    }

    cout << ans << endl;

    return 0;
}
