#include <bits/stdc++.h>

#define MAXN 100005

using namespace std;

int n, m;
vector<pair<int, char>> a;
bool ant[MAXN];
int turnl[MAXN], turnr[MAXN];
int maxTurnL[MAXN], maxTurnR[MAXN];

int toLeft(char dir) {
    if (dir == 'l') return 0;
    if (dir == 'r') return 2;
    return 1;
}

int toRigth(char dir) {
    if (dir == 'l') return 2;
    if (dir == 'r') return 0;
    return 1;
}

int main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);

    cin >> n >> m;
    for (int i = 1; i <= m; i++) {
        int idx; cin >> idx;
        char pos; cin >> pos;

        a.push_back({idx, pos});
        ant[idx] = true;
    }

    sort(a.begin(), a.end());

    for (auto [idx, dir] : a) {
        turnl[idx] = toLeft(dir);
        turnr[idx] = toRigth(idx);
    }

    for (int i = 1; i <= n; i++) {
        if (!ant[i]) maxTurnL[i] = maxTurnL[i - 1];
        else maxTurnL[i] = max(maxTurnL[i - 1], turnl[i]);
    }

    for (int i = n; i >= 1; i--) {
        if (!ant[i]) maxTurnR[i] = maxTurnR[i + 1];
        else maxTurnR[i] = max(maxTurnR[i + 1], turnr[i]);
    }

    int allL = maxTurnL[a.back().first] + a.back().first;
    int allR = maxTurnR[a[0].first] + n - a[0].first + 1;

    //cout << maxTurnL[a.back().first] << endl;
    //cout << allL << " " << allR << endl;

    int ans = min(allL, allR);

    for (int i = 1; i < m; i++) {
        //i -> left, (m - i) -> right
        int lastLidx = i - 1;
        int lastRidx = i;

        //cout << "test: " << max(maxTurnL[a[lastLidx].first] + a[lastLidx].first, maxTurnR[a[lastRidx].first] + n - a[lastRidx].first + 1) << endl;

        ans = min(ans, max(maxTurnL[a[lastLidx].first] + a[lastLidx].first, maxTurnR[a[lastRidx].first] + n - a[lastRidx].first + 1));
    }

    cout << ans - 2 << endl;

    return 0;
}
